<?php
/*
 * @package Recent Forum Topics
 * @version 2.0
 * @Author: Pipke(AdemaStudios)
 * @copyright Copyright (C) 2015, Pipke
 * @All rights reserved. 
 * @This SMF modification is subject to the BSD 2-Clause License
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
  
if (!defined('SMF'))
	die('Hacking attempt...');

function rft_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions) 
{
	$permissionList['board']['rft_permission_boost'] = array(false, 'rft_group', 'rft_group');
	$permissionList['board']['rft_permission_hide_topic_view'] = array(false, 'rft_group', 'rft_group');

	$permissionGroups['board']['simple'][] = 'rft_group';
	$permissionGroups['board']['classic'][] = 'rft_group';
}

function rft_blockarea(&$actionArray)
{
	$actionArray['rftblock'] = array('RecentForumTopics.php', 'rftblock');
}

function rft_mod_admin(&$areas)
{	
	global $txt;
	
	loadLanguage('RecentForumTopics');	
	
	$areas['config']['areas']['modsettings']['subsections']['recentforumtopics'] = array($txt['rft_name']);
}
	
function rft_mod_settings(&$sub_actions)
{
	global $context;	
	
	$sub_actions['recentforumtopics'] = 'rft_blockSettings';	
}

function rft_blockSettings($return_config = false)
{
	global $context, $scripturl, $txt, $modSettings, $user_info;
		
	// Setup action areas
	rft_action_area();
	
	// Setup categories and boards
	rft_cats_boards();
	
	// SP still installed or activated? And if sp_rft block is added or still exists, the block could be removed/deleted?	
	if (($modSettings['rft_sp_activated'] >= 1) && (!empty($modSettings['rft_sp_block'])))
		rft_sp_info();
		
	if (!empty($context['rft_unknown_areas'])) 
		$rft_total_areas = $context['rft_known_areas'] + $context['rft_unknown_areas'];	
	else
		$rft_total_areas = $context['rft_known_areas'];
		
		// Make it alphabetic important!
		natcasesort($rft_total_areas);
		
		//Add area placement backup block	
		if ($modSettings['rft_area_placement_where'] != 'sp_block_list')	
		updateSettings(array('rft_area_placement_backup' => $modSettings['rft_area_placement_where']));
		
		// Admin layout
		if (!empty($modSettings['rft_note_setting']))
			$config_vars[] = array('desc', 'rft_note_messages');
		
		$config_vars[] = array('title', 'rft_settings_title');
		$config_vars[] = array('check', 'rft_enable', 'help' => $txt['rft_enable_sub'],);
		$config_vars[] = array('check', 'rft_note_setting', 'javascript' => 'onchange="toggle_rft_note_setting();"');
		$config_vars[] = array('check', 'rft_note_button', 'force_div_id' => 'custom_note_button_div');
		
		if (!empty($modSettings['rft_note_setting']))		
			$config_vars[] = array('check', 'rft_note_clear', 'force_div_id' => 'custom_note_clear_div', 'onclick' => 'return document.getElementById(\'rft_note_clear\').checked ? confirm(\'' . $txt['rft_note_clear_confirm'] . '\') : true;');

		$config_vars[] = array('select', 'rft_numbertopics', array('3' => 3,'4' => 4,'5' => 5,'6' => 6,'7' => 7,'8' => 8,'9' => 9,'10' => $txt['10'],));
		$config_vars[] = array('select', 'rft_maxtopics', array('50' => 50,'60' => 60,'70' => 70,'80' => 80,'90' => 90,'100' => $txt['100'],));
		$config_vars[] = array('check', 'rft_disable_smfrecentposts', array('desc', 'rft_topic_solvednote'));
		$config_vars[] = array('select', 'rft_subject_topics', 'subtext' => $txt['rft_subject_topics_sub'], array('last' => $txt['rft_last'],'first' => $txt['rft_first'],));
		$config_vars[] = array('select', 'rft_link_topics', 'subtext' => $txt['rft_link_topics_sub'], array('last' => $txt['rft_last'],'first' => $txt['rft_first'],));
		$config_vars[] = array('select', 'rft_trimnumbers', 'subtext' => $txt['rft_trimnumbers_sub'], array('full' => $txt['rft_full'], '75' => 75, '70' => 70, '65' => 65, '60' => 60, '55' => 55, '50' => 50, '45' => 45, '40' => 40, '35' => 35, '30' => 30));
		$config_vars[] = array('check', 'rft_linktree');
		//$config_vars[] = array('check', 'rft_counter_viewnumbers', 'javascript' => 'onchange="toggle_rft_counter_viewnumbers();"');
		
		if ($modSettings['rft_sp_activated'] <= 1)
		 $config_vars[] = array('check', 'rft_collapse_block', 'force_div_id' => 'custom_collapse_div'); 
	 
		$config_vars[] = array('title', 'rft_layout_title');
		if ($modSettings['rft_sp_activated'] <= 1)
			$config_vars[] = array('check', 'rft_border', 'force_div_id' => 'custom_border_div');
		
		//$config_vars[] = array('text', 'rft_color_viewnumbers', 'subtext' => $txt['rft_color_sub'], 'force_div_id' => 'custom_counter_div', 'preinput' => '&#35;', 'size' => 6);
		$config_vars[] = array('text', 'rft_color_boost', 'subtext' => $txt['rft_color_sub'], 'preinput' => '&#35;', 'size' => 6);
		$config_vars[] = array('select', 'rft_postlinkicon', array('none' => $txt['rft_none'], 'first' => $txt['rft_first_poster'], 'last' => $txt['rft_last_poster'], 'both' => $txt['rft_both_poster']));
		$config_vars[] = array('select', 'rft_avatar', array('none' => $txt['rft_none'], 'first' => $txt['rft_first_poster'], 'last' => $txt['rft_last_poster'], 'both' => $txt['rft_both_poster']));
		$config_vars[] = array('check', 'rft_avatar_layout', 'subtext' => $txt['rft_avatar_layout_sub'],);
		$config_vars[] = array('select', 'rft_relative_date', array('0' => $txt['rft_smf_default'], '1' => $txt['rft_relative_default'], '2' => $txt['rft_relative2'], '3' => $txt['rft_relative3'], '4' => $txt['rft_relative4'], '5' => $txt['rft_relative5'], '6' => $txt['rft_relative6'], '7' => $txt['rft_relative7']));
		$config_vars[] = array('check', 'rft_menubuttons');
		$config_vars[] = array('check', 'rft_postingicons');
		$config_vars[] = array('title', 'rft_area_placement_title');
		
		if ($modSettings['rft_sp_activated'] == true)
			$config_vars[] = array('desc', 'rft_sp_block_note');	
		
		if (($modSettings['rft_sp_activated'] >= 1) && (!empty($modSettings['rft_sp_block'])))
		{
			$config_vars[] = array('select', 'rft_area_placement_where', array('above_only' => $txt['rft_above_area'], 'below_only' => $txt['rft_below_area'],'above_and_below' => $txt['rft_both_area'], 'sp_block_list' => $txt['rft_sp_block_list'],), 'disabled' => 'disabled', 'javascript' => 'onchange="toggle_rft_admin_area();"');
			$config_vars[] = array('var_message', 'rft_sp_block', 'help' => $txt['rft_sp_block_help'], 'preinput' => '<span style="margin-right:-2px;">'.$context['rft_sp_info']['state_icon'].'</span><span style="margin:-2px;">'.$context['rft_sp_info']['edit'].'</span><span style="margin:-2px;">'.$context['rft_sp_info']['move'].'</span><span style="margin:-2px;">'.$context['rft_sp_info']['delete'].'</span>');
		}
			
		if ($modSettings['rft_sp_activated'] <= 1)
			$config_vars[] = array('select', 'rft_area_placement_where', array('above_only' => $txt['rft_above_area'], 'below_only' => $txt['rft_below_area'],'above_and_below' => $txt['rft_both_area'], 'sp_block_list' => $txt['rft_sp_block_list'],), 'javascript' => 'onchange="toggle_rft_admin_area();"');
		
		if ($modSettings['rft_sp_activated'] <= 1)
		{
			$config_vars[] = array('select', 'rft_area_placement', array('select_all_pages' => $txt['rft_select_all_pages'], 'select_custom' => $txt['rft_select_custom']), 'force_div_id' => 'custom_select_pages_div', 'javascript' => 'onchange="toggle_rft_admin_area();"');
			$config_vars[] = array('select', 'rft_above_areas',			
				$rft_total_areas,			
					'subtext' => $txt['rft_above_areas_sub'],
					'help' => $txt['rft_select_help'],		
					'multiple' => true,	
					'force_div_id' => 'custom_area_above_div',
				);
			$config_vars[] = array('select', 'rft_below_areas',			
				$rft_total_areas,			
					'subtext' => $txt['rft_below_areas_sub'],
					'help' => $txt['rft_select_help'],
					'multiple' => true,	
					'force_div_id' => 'custom_area_below_div',
				);
			$config_vars[] = array('select', 'rft_set_areas', array('stop' => $txt['rft_stop'],'run' => $txt['rft_run'],),'force_div_id' => 'custom_area_set_div',);							
		}
		$config_vars[] = array('title', 'rft_permissions_title');
		$config_vars[] = array('desc', 'rft_note_permissions');
		
		if ($modSettings['rft_sp_activated'] <= 1)
		{
			if (!empty($context['db_group_perm']))
				$config_vars[] = array('select', 'rft_view_perm',			
				$context['db_group_perm'],			
				'subtext' => $txt['rft_view_perm_sub'],	
				'help' => $txt['rft_select_help'],		
				'multiple' => true,	
				'force_div_id' => 'custom_perm_div',
				);
		}
	
		$config_vars[] = array('select', 'rft_hide_cats',			
		$context['db_cur_cats'],			
		'subtext' => $txt['rft_hide_cats_sub'],
		'help' => $txt['rft_select_help'],		
		'multiple' => true,	
		
		);	
		
		$config_vars[] = array('select', 'rft_hide_boards',			
		$context['db_cur_boards'],			
		'subtext' => $txt['rft_hide_boards_sub'],
		'help' => $txt['rft_select_help'],
		'multiple' => true,	
		
		);
		if (!empty($context['db_hide_topics']))
		{
			$config_vars[] = '';
			$config_vars[] = array('select', 'rft_hide_topics',			
			$context['db_hide_topics'],			
			'subtext' => $txt['rft_hide_topics_sub'],
			'help' => $txt['rft_select_help'],
			'multiple' => true,		
			);
		}
					
		if ($return_config)		
			return $config_vars;	
		
		$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=recentforumtopics';
		if (!empty($modSettings['rft_note_setting']))
			$context['settings_title'] = $txt['rft_notification_title'];
		
		// We want javascript for our area placement options, permissions, boards, categories and simpelportal boxes.
		$context['settings_insert_below'] = '
		<script type="text/javascript"><!-- // --><![CDATA[
			function toggle_rft_note_setting()
			{
				var selectNote = document.getElementById("rft_note_setting").checked;
				
				if (selectNote)
				{
					document.getElementById("custom_note_button_div").style.display = "";
					document.getElementById("custom_note_button_div_dd").style.display = "";
					document.getElementById("custom_note_clear_div").style.display = "";
					document.getElementById("custom_note_clear_div_dd").style.display = "";
				}
				else
				{
					document.getElementById("custom_note_button_div").style.display = "none";
					document.getElementById("custom_note_button_div_dd").style.display = "none";
					document.getElementById("custom_note_clear_div").style.display = "none";
					document.getElementById("custom_note_clear_div_dd").style.display = "none";	
				}
			}
			function toggle_rft_admin_area()
			{
				var selectCustom = document.getElementById("rft_area_placement").value == "select_custom";
				var aboveOnly = document.getElementById("rft_area_placement_where").value == "above_only";
				var belowOnly = document.getElementById("rft_area_placement_where").value == "below_only"; 
				var allPages = document.getElementById("rft_area_placement").value == "select_all_pages";				
				var blockOnly = document.getElementById("rft_area_placement_where").value == "sp_block_list";
				
				if (allPages)
				{
					document.getElementById("custom_area_above_div").style.display = "none";
					document.getElementById("custom_area_above_div_dd").style.display = "none";
					document.getElementById("custom_area_below_div").style.display = "none";
					document.getElementById("custom_area_below_div_dd").style.display = "none";
					document.getElementById("custom_area_set_div").style.display = "none";
					document.getElementById("custom_area_set_div_dd").style.display = "none";
					document.getElementById("custom_select_pages_div").style.display = "";
					document.getElementById("custom_select_pages_div_dd").style.display = "";
					document.getElementById("custom_perm_div").style.display = "";	
					document.getElementById("custom_perm_div_dd").style.display = "";
					document.getElementById("custom_collapse_div").style.display = "";	
					document.getElementById("custom_collapse_div_dd").style.display = "";
					document.getElementById("custom_border_div").style.display = "";	
					document.getElementById("custom_border_div_dd").style.display = "";							
					
					
					if (allPages && aboveOnly)
					{
					document.getElementById("custom_area_above_div").style.display = "none";
					document.getElementById("custom_area_above_div_dd").style.display = "none";
					document.getElementById("custom_area_below_div").style.display = "none";
					document.getElementById("custom_area_below_div_dd").style.display = "none";
					document.getElementById("custom_area_set_div").style.display = "none";
					document.getElementById("custom_area_set_div_dd").style.display = "none";
					document.getElementById("custom_select_pages_div").style.display = "";
					document.getElementById("custom_select_pages_div_dd").style.display = "";
					document.getElementById("custom_perm_div").style.display = "";	
					document.getElementById("custom_perm_div_dd").style.display = "";
					document.getElementById("custom_collapse_div").style.display = "";	
					document.getElementById("custom_collapse_div_dd").style.display = "";
					document.getElementById("custom_border_div").style.display = "";	
					document.getElementById("custom_border_div_dd").style.display = "";							
					}
					
					if (allPages && belowOnly)
					{
					document.getElementById("custom_area_above_div").style.display = "none";
					document.getElementById("custom_area_above_div_dd").style.display = "none";
					document.getElementById("custom_area_below_div").style.display = "none";
					document.getElementById("custom_area_below_div_dd").style.display = "none";
					document.getElementById("custom_area_set_div").style.display = "none";
					document.getElementById("custom_area_set_div_dd").style.display = "none";
					document.getElementById("custom_select_pages_div").style.display = "";
					document.getElementById("custom_select_pages_div_dd").style.display = "";
					document.getElementById("custom_perm_div").style.display = "";	
					document.getElementById("custom_perm_div_dd").style.display = "";
					document.getElementById("custom_collapse_div").style.display = "";	
					document.getElementById("custom_collapse_div_dd").style.display = "";
					document.getElementById("custom_border_div").style.display = "";	
					document.getElementById("custom_border_div_dd").style.display = "";							
					}
					if (allPages && blockOnly)
					{
					document.getElementById("custom_area_above_div").style.display = "none";
					document.getElementById("custom_area_above_div_dd").style.display = "none";
					document.getElementById("custom_area_below_div").style.display = "none";
					document.getElementById("custom_area_below_div_dd").style.display = "none";
					document.getElementById("custom_area_set_div").style.display = "none";
					document.getElementById("custom_area_set_div_dd").style.display = "none";
					document.getElementById("custom_select_pages_div").style.display = "none";
					document.getElementById("custom_select_pages_div_dd").style.display = "none";
					document.getElementById("custom_perm_div").style.display = "none";	
					document.getElementById("custom_perm_div_dd").style.display = "none";
					document.getElementById("custom_collapse_div").style.display = "none";	
					document.getElementById("custom_collapse_div_dd").style.display = "none";
					document.getElementById("custom_border_div").style.display = "none";	
					document.getElementById("custom_border_div_dd").style.display = "none";						
					}
				}
					
				if (selectCustom)
				{
					document.getElementById("custom_area_above_div").style.display = "";
					document.getElementById("custom_area_above_div_dd").style.display = "";
					document.getElementById("custom_area_below_div").style.display = "";
					document.getElementById("custom_area_below_div_dd").style.display = "";
					document.getElementById("custom_area_set_div").style.display = "";
					document.getElementById("custom_area_set_div_dd").style.display = "";
					document.getElementById("custom_select_pages_div").style.display = "";
					document.getElementById("custom_select_pages_div_dd").style.display = "";
					document.getElementById("custom_perm_div").style.display = "";	
					document.getElementById("custom_perm_div_dd").style.display = "";
					document.getElementById("custom_collapse_div").style.display = "";	
					document.getElementById("custom_collapse_div_dd").style.display = "";
					document.getElementById("custom_border_div").style.display = "";	
					document.getElementById("custom_border_div_dd").style.display = "";						
					
					if (selectCustom && aboveOnly)
					{
					document.getElementById("custom_area_above_div").style.display = "";
					document.getElementById("custom_area_above_div_dd").style.display = "";
					document.getElementById("custom_area_below_div").style.display = "none";
					document.getElementById("custom_area_below_div_dd").style.display = "none";
					document.getElementById("custom_area_set_div").style.display = "";
					document.getElementById("custom_area_set_div_dd").style.display = "";
					document.getElementById("custom_perm_div").style.display = "";	
					document.getElementById("custom_perm_div_dd").style.display = "";
					document.getElementById("custom_collapse_div").style.display = "";	
					document.getElementById("custom_collapse_div_dd").style.display = "";
					document.getElementById("custom_border_div").style.display = "";	
					document.getElementById("custom_border_div_dd").style.display = "";						
					}
					
					if (selectCustom && belowOnly)
					{
					document.getElementById("custom_area_above_div").style.display = "none";
					document.getElementById("custom_area_above_div_dd").style.display = "none";
					document.getElementById("custom_area_below_div").style.display = "";
					document.getElementById("custom_area_below_div_dd").style.display = "";
					document.getElementById("custom_area_set_div").style.display = "";
					document.getElementById("custom_area_set_div_dd").style.display = "";
					document.getElementById("custom_perm_div").style.display = "";	
					document.getElementById("custom_perm_div_dd").style.display = "";
					document.getElementById("custom_collapse_div").style.display = "";	
					document.getElementById("custom_collapse_div_dd").style.display = "";
					document.getElementById("custom_border_div").style.display = "";	
					document.getElementById("custom_border_div_dd").style.display = "";						
					}
					
					if (selectCustom && blockOnly)
					{
					document.getElementById("custom_area_above_div").style.display = "none";
					document.getElementById("custom_area_above_div_dd").style.display = "none";
					document.getElementById("custom_area_below_div").style.display = "none";
					document.getElementById("custom_area_below_div_dd").style.display = "none";
					document.getElementById("custom_area_set_div").style.display = "none";
					document.getElementById("custom_area_set_div_dd").style.display = "none";
					document.getElementById("custom_select_pages_div").style.display = "none";
					document.getElementById("custom_select_pages_div_dd").style.display = "none";
					document.getElementById("custom_perm_div").style.display = "none";	
					document.getElementById("custom_perm_div_dd").style.display = "none";
					document.getElementById("custom_collapse_div").style.display = "none";	
					document.getElementById("custom_collapse_div_dd").style.display = "none";
					document.getElementById("custom_border_div").style.display = "none";	
					document.getElementById("custom_border_div_dd").style.display = "none";					
					}
				}
							
			}			
			toggle_rft_note_setting();
			toggle_rft_admin_area();
		// ]]></script>';
		
	if (empty($config_vars))
	{
		$context['settings_save_dont_show'] = false;
		$context['settings_message'] = '<div align="center">' . $txt['modification_no_misc_settings'] . '</div>';
		return prepareDBSettingContext($config_vars);	
	}
	
	// Save admin settings
	if (isset($_GET['save']))
	{		
		checkSession();	
		
		if ((empty($_POST['rft_enable'])) && ($modSettings['rft_sp_block'] == true))
			fatal_lang_error('rft_disable_rft', false);
		
		if ((empty($_POST['rft_enable'])) && ($_POST['rft_area_placement_where'] == 'sp_block_list'))
			fatal_lang_error('rft_cannot_save_sp', false);
				
		if (ctype_xdigit($_POST['rft_color_boost']) && (strlen($_POST['rft_color_boost']) == 6 || strlen($_POST['rft_color_boost']) == 3))
			/*empty space*/;
		else
			fatal_lang_error('rft_error_color_boost', false);
		
		if (($_POST['rft_area_placement_where'] == 'sp_block_list') && $modSettings['rft_sp_activated'] < 1)
			fatal_lang_error('rft_error_sp', false);		
			
		$context['save_vars'] = $config_vars;
		saveDBSettings($context['save_vars']);
		
		//Simple bug fix for 'multiple selections, unselect all' serialize in admin settings (SMF 2.0.11 or earlier versions)
		if (empty($_POST['rft_below_areas']))
			updateSettings(array('rft_below_areas' => false));
		
		if (empty($_POST['rft_above_areas']))
			updateSettings(array('rft_above_areas' => false));
		
		if (empty($_POST['rft_view_perm']))
			updateSettings(array('rft_view_perm' => false));
		
		if (empty($_POST['rft_hide_cats']))
			updateSettings(array('rft_hide_cats' => false));
		
		if (empty($_POST['rft_hide_boards']))
			updateSettings(array('rft_hide_boards' => false));
		
		if (empty($_POST['rft_hide_topics']))
			updateSettings(array('rft_hide_topics' => false));
		// Other things
		if (!empty($_POST['rft_note_clear']))
		{
			$mod_settings = array(
				'rft_note_counter' => 0,				
				'rft_note_messages' => '&#8226; '.$txt['rft_note_cleared'].' '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>',
				'rft_note_clear' => false,
				);
				updateSettings($mod_settings);
		}		
		
		//Set value back to default before used bock in list when we remove sp (kind of backup thingy)
		if (($_POST['rft_area_placement_where'] == 'sp_block_list') && $modSettings['rft_sp_activated'] == 1)
		{
			updateSettings(array('rft_sp_block' => true));
			rft_sp_block();
			redirectexit('action=admin;area=portalblocks;sa=list');	
		}
			
		redirectexit('action=admin;area=modsettings;sa=recentforumtopics');	
	}	

		prepareDBSettingContext($config_vars);
}

// Load the template if access?
function rft_load_themes()
{
	global $context, $settings, $modSettings, $user_info;

	loadLanguage('RecentForumTopics');

	if (in_array($context['current_action'], array('helpadmin', 'printpage')) || WIRELESS) 
		return;
	
	// How else you gonna find them?
		rft_search_mods();
	
	if (!empty($modSettings['rft_enable']))
	{
		if (!empty($modSettings['rft_disable_smfrecentposts']))
			$settings['number_recent_posts'] = 0;
		
		// Check groups wich cannot see, included post count group if selected, sp uses there own permissions!!
		if ($modSettings['rft_sp_block'] == false)
		{
			$rft_view_perm = !empty($modSettings['rft_view_perm']) ? unserialize($modSettings['rft_view_perm']) : array();
				
			$rft_cannot_see = false;
			foreach ($rft_view_perm as $allowed)
			if (in_array($allowed, $user_info['groups']))
			{
				$rft_cannot_see = true;
				break;
			}
			
			if ($rft_cannot_see)
			return;
		}
		
		RecentForumTopics_loading();
		
	}

}

// Go template go...
function RecentForumTopics_loading()
{
	global $context, $scripturl, $modSettings, $txt;
	
	// 3 VERY IMPORTANT STATEMENTS!!
	if (!empty($_REQUEST['action']) && in_array($_REQUEST['action'], array('dlattach', 'findmember', 'jseditor', 'jsoption', 'requestmembers', 'smstats', '.xml', 'xmlhttp', 'verificationcode', 'viewquery', 'viewsmfile')))
		return;
	
	if (!empty($_REQUEST['area']) && in_array($_REQUEST['area'], array('packages')))
		return;
	
	if (isset($_REQUEST['xml']))
		return;
		
	$context['html_headers'] .= '
	<style type="text/css">
	.lastpost img
	{
	padding: 0px;
	}

	.topic_table td.stickybg2rft
	{
	background-repeat: no-repeat;
	background-color: #F2E3D9;
	}

	.topic_table td.lockedbg2rft
	{
	background-repeat: no-repeat;
	background-color: #D8E1E7;
	font-style: italic;
	}

	.topic_table td.locked_sticky2rft
	{
	background-repeat: no-repeat;
	background-color: #E8D8CF;
	}
	
	.dropmenu 
	{   
    font-style: normal;
	}

	.windowbg2rft
	{
	color: #000;
	background-color: #F0F4F7;
	}

	.boost
	{
	background-color: #'.$modSettings['rft_color_boost'].';
	}	
	.rft-avatar 
	{ 
	width:32px;
	height:32px;
	border: none;
	align: middle;
	}
	
	.rft-avatar_round
	{ 
	width:32px;
	height:32px;
	border-radius: 50%;
	border: none;
	align: middle;
	}					

	.rft_actions
	{	
	font-size: 12px;
	color: rgba(0,0,0,0.9);
	background-color: rgba(0,0,255,0.1);
	border-radius: 8px;
	text-decoration:none;
	cursor: auto;
	margin:8px;
	padding:8px 12px;
	}
			
	.rftblockareaupdate
	{
	width: 100%;
	height: 100px;
	font-size: 32px;
	color: #9797f1;
	cursor: pointer;
	border-style: dashed;
	border-width: 2px;
	-moz-box-sizing: border-box;
	-webkit-box-sizing: border-box;
	box-sizing: border-box;
	text-decoration: none;
	text-align: center;
	vertical-align: middle;
	line-height: 90px;
	}
			
	.rftblockareaupdate:hover
	{
	color: rgba(255,255,255,1.0);
	background-color: rgba(0,0,255,0.5);
	}
			
	.rftblockarearemove
	{	
	width: 100%;
	height: 100px;
	font-size: 32px;
	color: rgba(255,0,0,0.5);
	cursor: pointer;
	border-style: dashed;
	border-width: 2px;
	-moz-box-sizing: border-box;
	-webkit-box-sizing: border-box;
	box-sizing: border-box;
	text-decoration: none;
	text-align: center;
	vertical-align: middle;
	line-height: 90px;
	}
			
	.rftblockarearemove:hover
	{		
	color: rgba(255,255,255,1.0);
	background-color: rgba(255,0,0,0.5);
	}
			
	a.rftblockarealink
	{		
	text-decoration: none;
	}
	
	div.sp_block
	{
	overflow: visible !important; 
	}
	
	dl.settings dd
	{
		overflow: visible !important; */ chrome: fix for multiple select-box in admin */
	}

	setttings.rft_sp_block_settings dd
	{
		margin: 0px;
	}
	</style>';
	
	rft_mainbasic();
	
	loadTemplate('RecentForumTopics');
	
	if (!empty($modSettings['rft_linktree']))
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=forum',
		'name' => $txt['rft_name']
	);
	
	$context['template_layers'][] = 'rft';
	return;	
}

// Do hidden categories-boards-topics, view permissions	and logging
function rft_cats_boards() 
{
	global $context, $modSettings, $smcFunc, $txt;
	
	// Check for hidden topics
	$rft_hide_topics = !empty($modSettings['rft_hide_topics']) ? unserialize($modSettings['rft_hide_topics']) : array();
	
	// Grab boards, categories, hidden topics, view permissions, usergroups
	$request = $smcFunc['db_query']('','			
	SELECT 
		b.id_board, b.name as board_name, b.redirect, ' . ($rft_hide_topics ? 'h.id_topic, h.subject,' : '') . '	
		g.id_group, g.group_name, c.id_cat, c.name AS cat_name
		FROM {db_prefix}boards AS b
		INNER JOIN {db_prefix}categories AS c 
		' . ($rft_hide_topics ? 'LEFT JOIN {db_prefix}messages AS h ON (h.id_topic = ({array_int:id_topics})) ' : '') . '
		INNER JOIN {db_prefix}membergroups AS g						
		WHERE id_group > {int:admin}',		
		array(			
		'admin' => 1,
		'id_topics' => $rft_hide_topics,	
		)								
	);	
	while ($row = $smcFunc['db_fetch_assoc']($request))	
	{
		// Categories
		$context['db_cur_cats'][$row['id_cat']] = $row['cat_name'];		
		
		// Boards
		if (empty($row['redirect']))
			$context['db_cur_boards'][$row['id_board']] = $row['board_name'];
	
		// Topics
		if (!empty($rft_hide_topics))
			$context['db_hide_topics'][$row['id_topic']] = $row['id_topic'].'=> '. $row['subject'];
		
		// Group permission view
		$group[$row['id_group']] = $row['group_name'];	
		$beginning = array(-1 => $txt['guests']);
		$context['db_group_perm'] = $beginning + $group;
	}
	$smcFunc['db_free_result']($request);
	
	// Make categories and boards alphabetic
	natcasesort($context['db_cur_cats']);
	natcasesort($context['db_cur_boards']);
	
	// Install take off categories and boards for db
	if (empty($modSettings['rft_cats']))
		updateSettings(array('rft_cats' => serialize($context['db_cur_cats'])));
	
	if (empty($modSettings['rft_boards']))
		updateSettings(array('rft_boards' => serialize($context['db_cur_boards'])));
		
		// Log note settings
		if (!empty($modSettings['rft_note_setting']))
		{			
			$rft_cats = !empty($modSettings['rft_cats']) ? unserialize($modSettings['rft_cats']) : array();		
			
			// Look for new categories
			$rft_new_cat = array_diff_key($context['db_cur_cats'], $rft_cats);

			if (!empty($rft_new_cat))			
			{				
				$rft_note_counter = $modSettings['rft_note_counter'] + 1;
				$rft_note_messages = '&#8226; '.$txt['rft_note_new_cat'].' &quot;'. array_shift($rft_new_cat) .'</a>&quot; '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
				$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
				$mod_settings = array(
				'rft_note_counter' => $rft_note_counter,				
				'rft_note_messages' => $rft_note_messages,
				'rft_cats' => serialize($context['db_cur_cats']),
				);
				updateSettings($mod_settings);
			}

			
			// Set new board notifications to db
			$rft_boards = !empty($modSettings['rft_boards']) ? unserialize($modSettings['rft_boards']) : array();		
			
			// Look for new board
			$rft_new_board = array_diff_key($context['db_cur_boards'], $rft_boards);  // moet naar key
				
			if (!empty($rft_new_board))			
			{				
				$rft_note_counter = $modSettings['rft_note_counter'] + 1;
				$rft_note_messages = '&#8226; '.$txt['rft_note_new_board'].' &quot;<a href="'.$scripturl.'?board='. key($rft_new_board) .'.0">'. array_shift($rft_new_board) .'</a>&quot; '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
				$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
				$mod_settings = array(
				'rft_note_counter' => $rft_note_counter,				
				'rft_note_messages' => $rft_note_messages,
				'rft_boards' => serialize($context['db_cur_boards']),
				);
				updateSettings($mod_settings);
			}			
		}
}

// Forum actions
function rft_action_area()
{
	global $context, $modSettings, $txt;
	
	// Get $actionArray hook easily.
	call_integration_hook('integrate_actions', array(&$actionArray));
		
		// Build the monstrous rft action array	
		$context['rft_basic_actions'] = array(
			'home' => $txt['rft_homepage'],
			'forum' => $txt['rft_forum'], // Boardindex
			'board' => $txt['rft_boards'],
			'post' =>  $txt['rft_posts'],
			'recent' => $txt['recent_posts'],
			'unread' => $txt['unread_topics_visit'],
			'unreadreplies' => $txt['unread_replies'],
			'profile' => $txt['profile'],
			'pm' => $txt['pm_short'],
			'calendar' => $txt['calendar'],
			'admin' =>  $txt['admin'],
			'login' =>  $txt['login'],
			'register' =>  $txt['register'],
			'stats' =>  $txt['forum_stats'],
			'search' =>  $txt['search'],
			'mlist' =>  $txt['members_list'],
			'moderate' =>  $txt['moderate'],
			'help' =>  $txt['help'],
			'who' =>  $txt['who_title'],
			'credits' =>  $txt['rft_credits'],
		);
		
		// Combine the hook with basic array
		if (!empty($actionArray))
		{
			$rft_known_actions = array_keys($actionArray);
			
			if (($key = array_search('rftblock', $rft_known_actions)) !== false) 
			{
			unset($rft_known_actions[$key]);
			}
			// What if $actionArray is now empty after cleaning up rftblock 
			$rft_known_actions_combine = array_combine($rft_known_actions, $rft_known_actions);
			$rft_known_actions_map = array_map('ucfirst', $rft_known_actions_combine); //first character value in caps
			$context['rft_known_areas'] = array_merge($context['rft_basic_actions'], $rft_known_actions_map);
		}
		else
			$context['rft_known_areas'] = $context['rft_basic_actions'];
		
		//make it alphabetic important!
		natcasesort($context['rft_known_areas']); 
		
		// Above compare basic+hook array key with db area array for unknown actions
		$rft_unknown_actions = !empty($modSettings['rft_above_areas']) ? unserialize($modSettings['rft_above_areas']) : array();
		$rft_unknown_actions_combine = array_combine($rft_unknown_actions, $rft_unknown_actions);
		$rft_unknown_actions_map_above = array_map('ucfirst', $rft_unknown_actions_combine);  //first character value in caps
		$context['rft_unknown_areas_above'] = array_diff_key($rft_unknown_actions_map_above, $context['rft_known_areas']);
		// Below
		$rft_unknown_actions = !empty($modSettings['rft_below_areas']) ? unserialize($modSettings['rft_below_areas']) : array();
		$rft_unknown_actions_combine = array_combine($rft_unknown_actions, $rft_unknown_actions);
		$rft_unknown_actions_map_below = array_map('ucfirst', $rft_unknown_actions_combine);  //first character value in caps
		$context['rft_unknown_areas_below'] = array_diff_key($rft_unknown_actions_map_below, $context['rft_known_areas']);
		// Combine unknown area's
		if (!empty($context['rft_unknown_areas_above']) || !empty($context['rft_unknown_areas_above']))
		{
			$context['rft_unknown_areas'] = $context['rft_unknown_areas_above'] + $context['rft_unknown_areas_below'];
			//make it alphabetic important!
			natcasesort($context['rft_unknown_areas']); 
		}
			
		// Show notification only if turned on and selected custom!
		$context['rft_db_actions'] = !empty($modSettings['rft_known_actions']) ? unserialize($modSettings['rft_known_actions']) : array();
		
		$rft_known_actions = serialize($context['rft_known_areas']);	
		// $actionArray to db for the notification
		$mod_settings = array(			
			'rft_known_actions' => $rft_known_actions,
		);
		updateSettings($mod_settings);
		
		// Log note settings
		if (!empty($modSettings['rft_note_setting']))
		{
			// Set new action pages notifications to db
			if ($modSettings['rft_area_placement'] == 'select_custom')
			{
				// Look for new action page
				$rft_new_action = array_diff_key($context['rft_known_areas'], $context['rft_db_actions']);
				
				if (!empty($rft_new_action))			
				{				
					$rft_note_counter = $modSettings['rft_note_counter'] + 1;
					$rft_note_messages = '&#8226; '.$txt['rft_note_new_action'].' &quot;<a href="'.$scripturl.'?action='. key($rft_new_action) .'">'. key($rft_new_action) .'</a>&quot; '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
					$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
					$mod_settings = array(
					'rft_note_counter' => $rft_note_counter,				
					'rft_note_messages' => $rft_note_messages,
					);
					updateSettings($mod_settings);
				}
			}
		}
	
	// Check where we are?
	if (($context['user']['is_admin']) && ($modSettings['rft_set_areas'] == 'run') && ($modSettings['rft_area_placement'] == 'select_custom'))
		rft_where();
}

// Lookout for mods, set notifications to db
function rft_search_mods()
{
	global $txt, $context, $modSettings, $sourcedir, $scripturl, $user_info, $smcFunc;
	
	require_once($sourcedir . '/Subs-Package.php');
		
	// Load the installed mods
	$installed_mods = loadInstalledPackages();
		
	// Search for Topic Solved
	$id_ts = rft_search_key_id('Topic Solved', $installed_mods);
		
	// Search for SimplePortal
	$id_sp = rft_search_key_id('SimplePortal', $installed_mods);
		
	// Log note settings
	if (!empty($modSettings['rft_note_setting']))
	{			
		if(empty($modSettings['rft_note_messages']))
			$modSettings['rft_note_messages'] = $txt['rft_welcome'];
				
		// Topic solved
		if (!empty($id_ts) && (empty($modSettings['rft_topic_solved'])))
		{
			// Check the version
			if ($installed_mods[$id_ts-1]['version'] === '1.1.1')
			{						
				$rft_note_counter = $modSettings['rft_note_counter'] + 1;
				$rft_note_messages = '&#8226; '.$txt['rft_note_topic_solved_on'].' '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
				$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
				$mod_settings = array(
				'rft_note_counter' => $rft_note_counter,				
				'rft_note_messages' => $rft_note_messages,
				);
				updateSettings($mod_settings);
			}
		}
				
		// Simpleportal				
		if (!empty($id_sp) && (empty($modSettings['rft_sp_activated'])))
		{
			// Check the version
			if (substr($installed_mods[$id_sp-1]['version'],0,3) === '2.3')  //only versions with 2.3.*
			{						
				$rft_note_counter = $modSettings['rft_note_counter'] + 1;
				$rft_note_messages = '&#8226; '.$txt['rft_note_simpelportal'].' '.$installed_mods[$id_sp-1]['version'].' '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
				$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
				$mod_settings = array(
				'rft_note_counter' => $rft_note_counter,				
				'rft_note_messages' => $rft_note_messages,
				);
				updateSettings($mod_settings);
			}
		}		
	}
		
	// Simpleportal
	if (!empty($id_sp) && (empty($modSettings['rft_sp_activated'])))
	{
		// Check the version
		if (substr($installed_mods[$id_sp-1]['version'],0,3) === '2.3')
			updateSettings(array('rft_sp_activated' => 1));  //on
	}
		
	if (!empty($id_sp) && ($modSettings['rft_sp_activated'] > 1))
		updateSettings(array('rft_area_placement_where' => 'sp_block_list'));
				
	if (empty($id_sp))
	{
		$mod_settings = array(
			'rft_sp_block' => 0,
			'rft_sp_activated' => 0,				
			'rft_area_placement_where' => $modSettings['rft_area_placement_backup'],
			);
		updateSettings($mod_settings);
	}	
		
	// Topic solved
	if (!empty($id_ts))
		updateSettings(array('rft_topic_solved' => true));
	else
		updateSettings(array('rft_topic_solved' => false));		
}

// Find the Recent Forum Topics
function rft_mainbasic()
{
	global $txt, $settings, $scripturl, $user_info, $context, $modSettings, $board, $smcFunc;
	
	// Show per page
	$rft_per_page = !empty($modSettings['rft_numbertopics']) ? $modSettings['rft_numbertopics'] : 10; 
	
	// Max topics to show  	**************this needs to be added as option in settings!!!! ***************
	$rft_max_topics = !empty($modSettings['rft_maxtopics']) ? $modSettings['rft_maxtopics'] : 100; 
	
	if (empty($_REQUEST['jump']))
		$_REQUEST['jump'] = 0;
	
	if (isset($_REQUEST['jump']) && $_REQUEST['jump'] > 108)
		$_REQUEST['jump'] = 108;
	
	$rft_query_parameters = array();
	
	//Default no boosted topics
	$query_order = 'm.id_msg DESC';	
	
	//Get last msg id(s) and if user can see the boosted topic(s)
	if (!empty($modSettings['rft_boost_1']) || !empty($modSettings['rft_boost_2']))
	{
		$rft['boosttopics'] = array($modSettings['rft_boost_1'], $modSettings['rft_boost_2']);
		// Only boosted 1 instead of 2
		if (!empty($modSettings['rft_boost_1']) && empty($modSettings['rft_boost_2']))  // 1 set 1
			$rft['boosttopics'] = array($modSettings['rft_boost_1']);
		if (empty($modSettings['rft_boost_1']) && !empty($modSettings['rft_boost_2']))  // 1 set 2
			$rft['boosttopics'] = array($modSettings['rft_boost_2']);
		
		$result = $smcFunc['db_query']('', '
			SELECT t.id_last_msg
			FROM {db_prefix}topics as t
			LEFT JOIN {db_prefix}boards as b ON (b.id_board = t.id_board)
			WHERE t.id_topic IN ({array_int:id_topics})	
			AND {query_see_board}
			',
			array(
				'id_topics' => $rft['boosttopics'],
			)
		);
		while ($row = $smcFunc['db_fetch_assoc']($result))
			$rft['boost_can_see'][] = $row['id_last_msg'];
		$smcFunc['db_free_result']($result);
	}
	
	//Two boosted topics set
	if (!empty($rft['boost_can_see']['1']))
	{
		// Highest id first
		if ($rft['boost_can_see']['1'] > $rft['boost_can_see']['0'])
			$query_order = 'm.id_msg='. $rft['boost_can_see']['1'] .' DESC, m.id_msg='. $rft['boost_can_see']['0'] .' DESC, m.id_msg DESC';
		else
			$query_order = 'm.id_msg='. $rft['boost_can_see']['0'] .' DESC, m.id_msg='. $rft['boost_can_see']['1'] .' DESC, m.id_msg DESC';
				
		$rft_per_page = $rft_per_page -2;
		$rft_max_topics = $rft_max_topics + $rft_per_page;
	}
	
	//One boosted topic set
	if (!empty($rft['boost_can_see']['0']) && (empty($rft['boost_can_see']['1'])))
	{
		$query_order = 'm.id_msg='. $rft['boost_can_see']['0'] .' DESC, m.id_msg DESC';
		$rft_per_page = $rft_per_page -1;
		$rft_max_topics = $rft_max_topics + $rft_per_page; 
	}

	$query_this_board = '{query_wanna_see_board}' . (!empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0 ? '
		AND b.id_board != {int:recycle_board}' : '') .
			(!empty($modSettings['rft_hide_cats']) && !empty($modSettings['rft_set_cats']) ? ' AND b.id_cat NOT IN ({array_int:rft_hide_categories})' : '') .
			(!empty($modSettings['rft_hide_boards']) && !empty($modSettings['rft_set_boards']) ? ' AND b.id_board NOT IN ({array_int:rft_hide_boards})' : '') .
			(!empty($modSettings['rft_hide_topics']) ? ' AND t.id_topic NOT IN ({array_int:rft_hide_topics})' : '') .	
			(!empty($modSettings['rft_boost_1']) ? ' AND t.id_topic NOT IN ({array_int:rft_boost_1})' : '') .	
			(!empty($modSettings['rft_boost_2']) ? ' AND t.id_topic NOT IN ({array_int:rft_boost_2})' : '') .'
		AND m.id_msg >= {int:max_id_msg}';
		$rft_query_parameters['max_id_msg'] = max(0, $modSettings['maxMsgID'] - $rft_max_topics - $_REQUEST['jump'] * 6);
		$rft_query_parameters['recycle_board'] = $modSettings['recycle_board'];
		
		// Construct the pages
		if (($context['current_action'] == 'post') || (!empty($context['current_topic'])))
			$context['rft_page_index'] = rft_constructPageIndex($scripturl . '?topic='. $context['current_topic']. '.'. $_REQUEST['start'], $_REQUEST['jump'], min($rft_max_topics, $modSettings['totalTopics']), $rft_per_page, false);
		
		elseif (($context['current_action'] == 'board') || (!empty($context['current_board'])))
			$context['rft_page_index'] = rft_constructPageIndex($scripturl . '?board='. $context['current_board']. '.'. $_REQUEST['start'], $_REQUEST['jump'], min($rft_max_topics, $modSettings['totalTopics']), $rft_per_page, false);			
		
		elseif (empty($context['current_action']))
		{		
			$context['rft_page_index'] = constructPageIndex($scripturl  . '?',$_REQUEST['start'], min($rft_max_topics, $modSettings['totalTopics']), $rft_per_page, false);
			$_REQUEST['jump'] = $_REQUEST['start'];
		}
		else
			$context['rft_page_index'] = rft_constructPageIndex($scripturl . '?action='. $context['current_action'].'', $_REQUEST['jump'], min($rft_max_topics, $modSettings['totalTopics']), $rft_per_page, false);
			
	$key = 'recent-' . $user_info['id'] . '-' . md5(serialize(array_diff_key($rft_query_parameters, array('max_id_msg' => 0)))) . '-' . (int) $_REQUEST['jump'];  // what does this line do anyway?
	
	
	if (($messages = cache_get_data($key, 60)) == false) 
    {
		$done = false;
		while (!$done)
		{
			// Find the ?? most recent messages they can *view*.
			// !!!SLOW This query is really slow still, probably?
			$request = $smcFunc['db_query']('', '
				SELECT m.id_msg
				FROM {db_prefix}messages AS m
					INNER JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
					INNER JOIN {db_prefix}topics AS t ON (t.' . (!empty($modSettings['rft_subject_topics']) && $modSettings['rft_subject_topics'] == 'last' ? 'id_last_msg' : 'id_first_msg') . ' = m.id_msg)
					WHERE ' . $query_this_board . '
					AND m.approved = {int:is_approved}
				ORDER BY m.id_msg DESC
				LIMIT {int:offset}, {int:limit}',
				array_merge($rft_query_parameters, array(
					'is_approved' => 1,
					'offset' => $_REQUEST['jump'],
					'limit' => $rft_per_page,
					'rft_hide_categories' => (!empty($modSettings['rft_hide_cats']) ? unserialize($modSettings['rft_hide_cats']) : ''),
					'rft_hide_boards' => (!empty($modSettings['rft_hide_boards']) ? unserialize($modSettings['rft_hide_boards']) : ''),
					'rft_hide_topics' => (!empty($modSettings['rft_hide_topics']) ? unserialize($modSettings['rft_hide_topics']) : ''),
					'rft_boost_1' => (!empty($modSettings['rft_boost_1']) ? explode(',',$modSettings['rft_boost_1']) : ''),
					'rft_boost_2' => (!empty($modSettings['rft_boost_2']) ? explode(',',$modSettings['rft_boost_2']) : ''),
				))
			);
			
			// If we don't have 10 results, try again with an unoptimized version covering all rows, and cache the result.
			if (isset($rft_query_parameters['max_id_msg']) && $smcFunc['db_num_rows']($request) < 7)
			{
				$smcFunc['db_free_result']($request);
				$query_this_board = str_replace('AND m.id_msg >= {int:max_id_msg}', '', $query_this_board);
				$cache_results = true;
				unset($rft_query_parameters['max_id_msg']);
			}
			else
				$done = true;
		}
		$messages = array();
		while ($row = $smcFunc['db_fetch_assoc']($request))
			$messages[] = $row['id_msg'];
			if (!empty($rft['boost_can_see']['0']))
				$messages[] = $rft['boost_can_see']['0'];
			if (!empty($rft['boost_can_see']['1']))
				$messages[] = $rft['boost_can_see']['1'];
		$smcFunc['db_free_result']($request);
		if (!empty($cache_results))
			cache_put_data($key, $messages, 60);
    }
	
	// Nothing here... Or at least, nothing you can see...
	if (empty($messages))
	{
		$context['rft_posts'] = array();
		return;
	}
	
	// setvar
	$modSettings['custom_avatar_url'] = false;  // huh?
		
	// Check if Column 'is_solved' exists from the Topic Solved Mod
	$tableName = 'topics';
	$columnName = 'is_solved';
	$solved_exists = false;
	$solved_exists = rft_checkColumn($tableName, $columnName);
	
	// Get all the most recent posts
	$request = $smcFunc['db_query']('', '
        SELECT
            m.id_msg, m.id_msg_modified, m.subject, m.smileys_enabled, m.poster_time AS first_poster_time , m.body, m.id_topic, t.id_board, b.id_cat,
			IFNULL(av2.id_attach, 0) AS id_attach2, av2.filename, av2.attachment_type,
			IFNULL(av.id_attach, 0) AS id_attach, av.filename, av.attachment_type,
            b.name AS bname, c.name AS cname, t.num_replies, t.num_views, m.id_member, m2.id_member AS id_first_member,' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from') . ',
            m2.poster_time AS last_poster_time, m.icon AS first_icon,
            t.approved, t.unapproved_posts, t.locked, t.is_sticky, t.id_poll,' . ($solved_exists ? ' t.is_solved,' : '') . '
            IFNULL(mem2.real_name, m2.poster_name) AS first_poster_name, t.id_first_msg, mem2.avatar AS avatar_first_poster,
            IFNULL(mem.real_name, m.poster_name) AS poster_name, t.id_last_msg, mem.avatar AS avatar_poster
        FROM {db_prefix}messages AS m
            INNER JOIN {db_prefix}topics AS t ON (t.id_topic = m.id_topic)
            INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
            INNER JOIN {db_prefix}categories AS c ON (c.id_cat = b.id_cat)
            INNER JOIN {db_prefix}messages AS m2 ON (m2.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}attachments AS av2 ON (av2.id_member = m2.id_member)
			LEFT JOIN {db_prefix}attachments AS av ON (av.id_member = m.id_member)
            LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)
            LEFT JOIN {db_prefix}members AS mem2 ON (mem2.id_member = m2.id_member)' . (!$user_info['is_guest'] ? '
            LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = m.id_topic AND lt.id_member = {int:current_member})
            LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = m.id_board AND lmr.id_member = {int:current_member})' : '') . '
        WHERE m.id_msg IN ({array_int:message_list})   
       ORDER BY ' . $query_order . '
		' . (count($messages) == '' ? '' : 'LIMIT ' . count($messages)),
    array(
        'message_list' => $messages,
        'current_member' => $user_info['id'],
    )
);
	
	$counter = $_REQUEST['jump'] + 1;
	$context['rft_posts'] = array();
	$board_ids = array('own' => array(), 'any' => array());
	$topics = array();
	
	//pages topic
	$context['messages_per_page'] = empty($modSettings['disableCustomPerPage']) && !empty($options['messages_per_page']) && !WIRELESS ? $options['messages_per_page'] : $modSettings['defaultMaxMessages'];
	
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{

    // Censor everything.
    censorText($row['subject']);

    // BBC-atize the message.
    $row['body'] = parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']);
    
	// Decide how many pages the topic should have.
			if ($row['num_replies'] + 1 > $context['messages_per_page'])
			{
				$pages = '&#171; ';

				// We can't pass start by reference.
				$start = -1;
				$pages .= rft_constructPageIndex($scripturl . '?topic=' . $row['id_topic'] . '.%1$d', $start, $row['num_replies'] + 1, $context['messages_per_page'], true);

				// If we can use all, show all.
				if (!empty($modSettings['enableAllMessages']) && $row['num_replies'] + 1 < $modSettings['enableAllMessages'])
					$pages .= ' &nbsp;<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0;all">' . $txt['all'] . '</a>';
				$pages .= ' &#187;';
			}
			else
				$pages = '';
				
	$topics[] = $row['id_topic'];	
	
	// The subject topic count numbers.	
	$rft_counter = $_REQUEST['jump'] / ($modSettings['rft_numbertopics']-1) +1;
	if (empty($context['rft_boost_msg1']) && empty($context['rft_boost_msg2']) && (empty($context['rft_boost']['id_last_msg'])))
		$rft_counter = $_REQUEST['jump'] / ($modSettings['rft_numbertopics']) +1;
	if (!empty($context['rft_boost_msg1']) && !empty($context['rft_boost_msg2']) && (empty($context['rft_boost']['id_last_msg'])))
		$rft_counter = $_REQUEST['jump'] / ($modSettings['rft_numbertopics']-2) +1;
		 	
    // And build the array.
    $context['rft_posts'][$row['id_msg']] = array(
        'id' => $row['id_msg'],
        'counter' => $counter++,
        'alternate' => $counter % 2,
        'category' => array(
            'id' => $row['id_cat'],
            'name' => $row['cname'],
            'href' => $scripturl . '#c' . $row['id_cat'],
            'link' => '<a href="' . $scripturl . '#c' . $row['id_cat'] . '">' . $row['cname'] . '</a>'
        ),
        'board' => array(
            'id' => $row['id_board'],
            'name' => $row['bname'],
            'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
            'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['bname'] . '</a>'
        ),
        'topic' => $row['id_topic'],
        'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#msg' . $row['id_msg'],
        'linklast' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#msg' . $row['id_msg']. '" rel="nofollow">' . rft_subject_trim($row['subject'], $modSettings['rft_trimnumbers']) . '</a>',
        'linkfirst' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0" rel="nofollow">' . rft_subject_trim($row['subject'], $modSettings['rft_trimnumbers']) . '</a>',
        'jump' => $row['num_replies'],
        'subject' => $row['subject'],
		'pages' => $pages,
        'views' => comma_format($row['num_views']),
        'replies' => comma_format($row['num_replies']),
        'timefirst' => timeformat($row['first_poster_time']),
		'time_first' => rft_relative_format($row['first_poster_time']),
		'about_first' => strpos(rft_relative_format($row['first_poster_time']), $txt['rft_second']) !== false || strpos(rft_relative_format($row['first_poster_time']), $txt['rft_minute']) !== false ? 0 : 1,
        'timelast' => timeformat($row['last_poster_time']),
		'time_last' => rft_relative_format($row['last_poster_time']),
		'about_last' => strpos(rft_relative_format($row['last_poster_time']), $txt['rft_second']) !== false || strpos(rft_relative_format($row['last_poster_time']), $txt['rft_minute']) !== false? 0 : 1,
        'first_poster' => array(
            'id' => $row['id_first_member'],
            'name' => $row['first_poster_name'],
            'href' => empty($row['id_first_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_first_member'],
            'link' => empty($row['id_first_member']) ? $row['first_poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_first_member'] . '">' . $row['first_poster_name'] . '</a>'
        ),
        'poster' => array(
            'id' => $row['id_member'],
            'name' => $row['poster_name'],
            'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
            'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
        ),
		'avatar_first_poster' => array(
			'href' => $row['avatar_first_poster'] == '' ? ($row['id_attach2'] > 0 ? (empty($row['av2.attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach2'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['av2.filename']) : '') : (stristr($row['avatar_first_poster'], 'http://') ? $row['avatar_first_poster'] : $modSettings['avatar_url'] . '/' . $row['avatar_first_poster']),
		),
		'avatar_poster' => array(
			'href' => $row['avatar_poster'] == '' ? ($row['id_attach'] > 0 ? (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar_poster'], 'http://') ? $row['avatar_poster'] : $modSettings['avatar_url'] . '/' . $row['avatar_poster']),
		),
        'is_own_post' => false,
        'new' => $row['new_from'] <= $row['id_msg_modified'],
        'new_from' => $row['id_msg'],
        'newtime' => $row['new_from'],
		'new_href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['new_from'] . ';topicseen#new" rel="nofollow"><img src="' . $settings['lang_images_url'] . '/new.gif" alt="' . $txt['new'],
        'id_msg_modified' => $row['id_msg_modified'],
        'is_sticky' => !empty($modSettings['enableStickyTopics']) && !empty($row['is_sticky']),
        'is_locked' => !empty($row['locked']),
        'is_poll' => $modSettings['pollMode'] == '1' && $row['id_poll'] > 0,
        'is_hot' => $row['num_replies'] >= $modSettings['hotTopicPosts'],
        'is_very_hot' => $row['num_replies'] >= $modSettings['hotTopicVeryPosts'],
        'icon' => $row['first_icon'],
		'message' => $row['body'],
		'can_reply' => false,
		'can_mark_notify' => false,
		'can_delete' => false,
		'delete_possible' => ($row['id_first_msg'] != $row['id_msg'] || $row['id_last_msg'] == $row['id_msg']) && (empty($modSettings['edit_disable_time']) || $row['poster_time'] + $modSettings['edit_disable_time'] * 60 >= time()),
		
    );
    if (!empty($row['is_solved']))
        $context['rft_posts'][$row['id_msg']]['is_solved'] = $row['is_solved'];
    if ($user_info['id'] == $row['id_first_member'])
        $board_ids['own'][$row['id_board']][] = $row['id_msg'];
    $board_ids['any'][$row['id_board']][] = $row['id_msg'];
}

	$smcFunc['db_free_result']($request);

	$request = $smcFunc['db_query']('', '
		SELECT DISTINCT id_topic
		FROM {db_prefix}messages
		WHERE id_topic IN ({array_int:topics})
		AND id_member = {int:member}',
	array(
		'topics' => $topics,
		'member' => $user_info['id'],
		)
	);
	$context['posted_topics'] = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
		$context['posted_topics'][] = $row['id_topic'];
	
	$smcFunc['db_free_result']($request);	 
	
	// There might be - and are - different permissions between any and own.	
	$permissions = array(
		'own' => array(
			'lock_own' => 'can_lock',
		),
		'any' => array(
			'make_sticky' => 'can_sticky',
			'lock_any' => 'can_lock',
			'mark_any_notify' => 'can_mark_notify',
			'rft_permission_boost' => 'can_boost',
			'rft_permission_hide_topic_view ' => 'can_hide',
		)
	);
	
	// Now go through all the permissions, looking for boards they can do it on.
	foreach ($permissions as $type => $list)
	{
		foreach ($list as $permission => $allowed)
		{
			// They can do it on these boards...
			$boards = boardsAllowedTo($permission);

			// If 0 is the only thing in the array, they can do it everywhere!
			if (!empty($boards) && $boards[0] == 0)
				$boards = array_keys($board_ids[$type]);

			// Go through the boards, and look for posts they can do this on.
			foreach ($boards as $board_id)
			{
				// Hmm, they have permission, but there are no topics from that board on this page.
				if (!isset($board_ids[$type][$board_id]))
					continue;

				// Okay, looks like they can do it for these posts.
				foreach ($board_ids[$type][$board_id] as $counter)
				
				if ($type == 'any' || $context['rft_posts'][$counter]['poster']['id'] == $user_info['id'])
					$context['rft_posts'][$counter][$allowed] = true;
			}
		}
	}
}

// Get last msg id for boosted topic?
function rft_boost_topic() 
{
	global $context, $smcFunc;
	
	//Get last msg id(s) and if user can see the boosted topic(s)
	$result = $smcFunc['db_query']('', '
		SELECT t.id_last_msg
		FROM {db_prefix}topics as t
		LEFT JOIN {db_prefix}boards as b ON (b.id_board = t.id_board)
		WHERE t.id_topic IN ({array_int:id_topics})	
			AND {query_see_board}
		',
		array(
			'id_topics' => $context['boosttopic'],
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($result))
		$context['boost_topic_can_see'][] = $row['id_last_msg'];
	$smcFunc['db_free_result']($result);
}

// Check where we are?
function rft_where()
{
	global $context, $modSettings;
		
	$context['rft_redirect'] = 'action='. $context['current_action'];
	
	// Index or Portal?
	if (empty($_REQUEST['action'])) 
	{
		$context['current_action'] = 'home';
		$context['rft_redirect'] = '';
	}
	
	// Boardindex
	if (($context['current_action'] == 'forum') || ($context['current_action'] == 'collapse')) 
	{
		$context['current_action'] = 'forum';
		$context['rft_redirect'] = 'action='. $context['current_action'];	
	}	
	
	// Board
	if (!empty($_REQUEST['board']) && empty($_REQUEST['topic']))
	{	
		$context['current_action'] = 'board';
		$context['rft_redirect'] = 'board='. $context['current_board']. '.'. $_REQUEST['start'];
	}
	
	// Post/Topic
	if (empty($_REQUEST['board']) && !empty($_REQUEST['topic']))
	{
		$context['current_action'] = 'post';
		$context['rft_redirect'] = 'topic='. $context['current_topic']. '.'. $_REQUEST['start'];
	}
		
	// Add current action and redirect to database
	if ($context['current_action'] != 'rftblock')
	{
		$mod_settings = array(			
			'rft_current_action' => $context['current_action'],
			'rft_redirect' => $context['rft_redirect'],
		);
		updateSettings($mod_settings);	
	}

	// Check in the two array's for unknown action pages	
	if (!empty($context['rft_known_areas']))
	{
		if (array_key_exists($modSettings['rft_current_action'], $context['rft_known_areas']))		
			$context['rft_unknown_actions'] = true;		
		else
			$context['rft_unknown_actions'] = false;
	}				
}

// Check Column Fields in Database
function rft_checkColumn($tableName, $columnName)
{
	global $smcFunc;

	$check = $smcFunc['db_query']('', 'DESCRIBE {db_prefix}' . $tableName . ' ' . $columnName);
	if ($smcFunc['db_num_rows']($check) > 0) 
		return true;
		
	return false;
}

// Mod name check if they are installed wich may affect this mod.
function rft_search_key_id($id, $array) 
{
	foreach ($array as $key => $val) 
	{
		if ($val['name'] === $id) 
			return $key +1;      
	}
	
	return null;
}

// Pagination
function rft_constructPageIndex($base_url, &$start, $max_value, $num_per_page, $flexible_start = false)
{
	global $modSettings;

	// Save whether $start was less than 0 or not.
	$start = (int) $start;
	$start_invalid = $start < 0;

	// Make sure $start is a proper variable - not less than 0.
	if ($start_invalid)
		$start = 0;
	// Not greater than the upper bound.
	elseif ($start >= $max_value)
		$start = max(0, (int) $max_value - (((int) $max_value % (int) $num_per_page) == 0 ? $num_per_page : ((int) $max_value % (int) $num_per_page)));
	// And it has to be a multiple of $num_per_page!
	else
		$start = max(0, (int) $start - ((int) $start % (int) $num_per_page));

	// Wireless will need the protocol on the URL somewhere.
	if (WIRELESS)
		$base_url .= ';' . WIRELESS_PROTOCOL;

	$base_link = '<a class="navPages" href="' . ($flexible_start ? $base_url : strtr($base_url, array('%' => '%%')) . ';jump=%1$d') . '">%2$s</a> ';

	// Compact pages is off or on?
	if (empty($modSettings['compactTopicPagesEnable']))
	{
		// Show the left arrow.
		$pageindex = $start == 0 ? ' ' : sprintf($base_link, $start - $num_per_page, '&#171;');

		// Show all the pages.
		$display_page = 1;
		for ($counter = 0; $counter < $max_value; $counter += $num_per_page)
			$pageindex .= $start == $counter && !$start_invalid ? '<strong>' . $display_page++ . '</strong> ' : sprintf($base_link, $counter, $display_page++);

		// Show the right arrow.
		$display_page = ($start + $num_per_page) > $max_value ? $max_value : ($start + $num_per_page);
		if ($start != $counter - $max_value && !$start_invalid)
			$pageindex .= $display_page > $counter - $num_per_page ? ' ' : sprintf($base_link, $display_page, '&#187;');
	}
	else
	{
		// If they didn't enter an odd value, pretend they did.
		$PageContiguous = (int) ($modSettings['compactTopicPagesContiguous'] - ($modSettings['compactTopicPagesContiguous'] % 2)) / 2;

		// Show the first page. (>1< ... 6 7 [8] 9 10 ... 15)
		if ($start > $num_per_page * $PageContiguous)
			$pageindex = sprintf($base_link, 0, '1');
		else
			$pageindex = '';

		// Show the ... after the first page.  (1 >...< 6 7 [8] 9 10 ... 15)
		if ($start > $num_per_page * ($PageContiguous + 1))
			$pageindex .= '<span style="font-weight: bold;" onclick="' . htmlspecialchars('expandPages(this, ' . JavaScriptEscape(($flexible_start ? $base_url : strtr($base_url, array('%' => '%%')) . ';jump=%1$d')) . ', ' . $num_per_page . ', ' . ($start - $num_per_page * $PageContiguous) . ', ' . $num_per_page . ');') . '" onmouseover="this.style.cursor = \'pointer\';"> ... </span>';

		// Show the pages before the current one. (1 ... >6 7< [8] 9 10 ... 15)
		for ($nCont = $PageContiguous; $nCont >= 1; $nCont--)
			if ($start >= $num_per_page * $nCont)
			{
				$tmpStart = $start - $num_per_page * $nCont;
				$pageindex.= sprintf($base_link, $tmpStart, $tmpStart / $num_per_page + 1);
			}

		// Show the current page. (1 ... 6 7 >[8]< 9 10 ... 15)
		if (!$start_invalid)
			$pageindex .= '[<strong>' . ($start / $num_per_page + 1) . '</strong>] ';
		else
			$pageindex .= sprintf($base_link, $start, $start / $num_per_page + 1);

		// Show the pages after the current one... (1 ... 6 7 [8] >9 10< ... 15)
		$tmpMaxPages = (int) (($max_value - 1) / $num_per_page) * $num_per_page;
		for ($nCont = 1; $nCont <= $PageContiguous; $nCont++)
			if ($start + $num_per_page * $nCont <= $tmpMaxPages)
			{
				$tmpStart = $start + $num_per_page * $nCont;
				$pageindex .= sprintf($base_link, $tmpStart, $tmpStart / $num_per_page + 1);
			}

		// Show the '...' part near the end. (1 ... 6 7 [8] 9 10 >...< 15)
		if ($start + $num_per_page * ($PageContiguous + 1) < $tmpMaxPages)
			$pageindex .= '<span style="font-weight: bold;" onclick="expandPages(this, \'' . ($flexible_start ? strtr($base_url, array('\'' => '\\\'')) : strtr($base_url, array('%' => '%%', '\'' => '\\\'')) . ';jump=%1$d') . '\', ' . ($start + $num_per_page * ($PageContiguous + 1)) . ', ' . $tmpMaxPages . ', ' . $num_per_page . ');" onmouseover="this.style.cursor=\'pointer\';"> ... </span>';

		// Show the last number in the list. (1 ... 6 7 [8] 9 10 ... >15<)
		if ($start + $num_per_page * $PageContiguous < $tmpMaxPages)
			$pageindex .= sprintf($base_link, $tmpMaxPages, $tmpMaxPages / $num_per_page + 1);
	}

	return $pageindex;
}

// Time format
function rft_relative_format($time)
{
    global $txt, $modSettings;
	
	if (empty($modSettings['rft_relative_date']))
		return;
	
	//The elapsed amount of time in seconds (integers only please!)
    $elapsed = time() - floor($time);
    //Is there any real difference?
    if ($elapsed < 1) { return '0 '. $txt['rft_seconds']; }
    //Setup an array of all possible time differences to check against
    $times = array (
        12 * 30 * 24 * 60 * 60  =>  'yr', // year
        30 * 24 * 60 * 60       =>  'mh', // month
        07 * 24 * 60 * 60       =>  'wk', // week
        24 * 60 * 60            =>  'dy', // day
        60 * 60                 =>  'hr', // hour
        60                      =>  'me', // minute
        1                       =>  'sd' ); //second
    //Setup a return string
    $return = '';
	$i = 0;
    //Loop through all of the time "constants"
    foreach ($times as $seconds => $string)
    {       
		//Get the difference
        $difference = floor($elapsed / $seconds);
        //Is there an actual (positive) difference?
        if ($difference >= 1)
        {
            //Add this difference to the return string. 
            $return .= " $difference $string" . ($difference > 1 ? 's' : '') . ',';
				
			//Should we continue adding all possible differences?
			if ($i == $modSettings['rft_relative_date'] -1) {
			break;
			} 
   			$i++;
            //Subtract this difference from the total elapsed for the next loop
            $elapsed -= $difference * $seconds;
        }		
    }
	$return = explode(',', $return);
	
	//Your language
	$replacements = array('yrs', 'yr', 'mhs', 'mh', 'wks', 'wk', 'dys', 'dy', 'hrs', 'hr', 'mes', 'me', 'sds', 'sd');
	$replacements2 = array($txt['rft_years'], $txt['rft_year'], $txt['rft_months'], $txt['rft_month'], $txt['rft_weeks'], $txt['rft_week'], $txt['rft_days'], $txt['rft_day'], $txt['rft_hours'], $txt['rft_hour'], $txt['rft_minutes'], $txt['rft_minute'], $txt['rft_seconds'], $txt['rft_second']);

    //Strip the final comma from the string before returning it
    $return = substr(implode(',',$return), 0, -1) . $txt['rft_ago'];
	
	return(str_replace($replacements, $replacements2, $return));
}

function rft_subject_trim($input, $length, $ellipses = true, $strip_tag = true) 
{
    //strip tags, if desired
    if ($strip_tag) {
        $input = strip_tags($input);
    }

    if($length == 'full')
		$trimmed_text=$input;
    else
    {
        //no need to trim, already shorter than trim length
        if (strlen($input) <= $length) 
			return $input;
        
        //find last space within length
        $last_space = strrpos(substr($input, 0, $length), ' ');
        $trimmed_text = substr($input, 0, $last_space);

        //add ellipses (...)
        if ($ellipses) 
			$trimmed_text .= '...';               
    }

    return $trimmed_text;
}

// Simpelportalblock add to db blocklist
function rft_sp_block()
{
	global $txt, $smcFunc, $user_info, $modSettings, $scripturl;
	
	$rft_block = array(
		'rft' => array(
			'label' => $txt['rft_name'],
			'type' => 'sp_rft',
			'col' => 2,
			'state'=> 1, //on
			'permission_set' => '3',
			'display' => 'all',
			'display_custom' => '',
			'style' => 'title_default_class~catbg|title_custom_class~|title_custom_style~|body_default_class~roundframe|body_custom_class~|body_custom_style~|no_title~|no_body~',
			),
		);

	$smcFunc['db_insert']('ignore',
		'{db_prefix}sp_blocks',
			array(
			'label' => 'text',
			'type' => 'text',
			'col' => 'int',
			'state' => 'int',
			'permission_set' => 'int',
			'display' => 'text',
			'display_custom' => 'text',
			'style' => 'text',
			),
		$rft_block,
		array('id_block')
		);
	
	$rft_note_counter = $modSettings['rft_note_counter'] + 1;
	$rft_note_messages = '&#8226; '.$txt['rft_note_simpelportal_on'].' '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
	$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
	$mod_settings = array(
		'rft_note_counter' => $rft_note_counter,				
		'rft_note_messages' => $rft_note_messages,
		);
		updateSettings($mod_settings);			
}

// Grab block id sp_rft
function rft_sp_info() 
{	
	global $smcFunc, $modSettings, $context, $txt, $scripturl, $user_info;	
		
		loadLanguage('SPortalAdmin');
		
		$context['rft_sp_info'] = array();  //setvar	
	
	if($modSettings['rft_sp_activated'] >= 1)
	{
		$request = $smcFunc['db_query']('', '		
			SELECT id_block, col, row, state
			FROM {db_prefix}sp_blocks	
			WHERE type = {text:type}',
			array(			
			'type' => 'sp_rft',
			)	
		);
		while ($row = $smcFunc['db_fetch_assoc']($request))
		$context['rft_sp_info'] = array(
			'id' => $row['id_block'],	
			'col' => $row['col'],
			'row' => $row['row'],
			'state' => $row['state'],
			'state_icon' => empty($row['state']) ? '<a href="' . $scripturl . '?action=admin;area=portalblocks;sa=statechange;' . (empty($context['sp_blocks_single_side_list']) ? '' : 'redirect=' . $row['col'] . ';') . 'block_id=' . $row['id_block'] . ';type=block;' . $context['session_var'] . '=' . $context['session_id'] . '">' . sp_embed_image('deactive', $txt['sp-blocksActivate']) . '</a>' : '<a href="' . $scripturl . '?action=admin;area=portalblocks;sa=statechange;' . (empty($context['sp_blocks_single_side_list']) ? '' : 'redirect=' . $row['col'] . ';') . 'block_id=' . $row['id_block'] . ';type=block;' . $context['session_var'] . '=' . $context['session_id'] . '">' . sp_embed_image('active', $txt['sp-blocksDeactivate']) . '</a>',
			'edit' => '<a href="' . $scripturl . '?action=admin;area=portalblocks;sa=edit;block_id=' . $row['id_block'] . ';' . $context['session_var'] . '=' . $context['session_id'] . '">' . sp_embed_image('modify') . '</a>',
			'move' => '<a href="' . $scripturl . '?action=admin;area=portalblocks;sa=select;block_id=' . $row['id_block'] . ';' . $context['session_var'] . '=' . $context['session_id'] . '">' . sp_embed_image('move', $txt['sp-adminColumnMove']) . '</a>',
			'delete' => '<a href="' . $scripturl . '?action=admin;area=portalblocks;sa=delete;block_id=' . $row['id_block'] . ';col=' . $row['col'] . ';' . $context['session_var'] . '=' . $context['session_id'] . '" onclick="return confirm(\''.$txt['sp-deleteblock'].'\');">' . sp_embed_image('delete') . '</a>',
		);
		$smcFunc['db_free_result']($request);
	
		if (!empty($modSettings['rft_sp_activated']))
		{
			if (empty($context['rft_sp_info']['id']))
			{
				$mod_settings = array(
				'rft_sp_block' => 0,
				);					
				updateSettings($mod_settings);
			}
		}
				
		// Is the SP block deleted after activated or deleted SP totally?
		if (empty($modSettings['rft_sp_block']))
		{
			if ($modSettings['rft_sp_activated'] > 1)
			{
				$mod_settings = array(
					'rft_sp_activated' => 1,
					'rft_area_placement_where' => $modSettings['rft_area_placement_backup'],
					);
					updateSettings($mod_settings);
												
				if (!empty($modSettings['rft_note_setting']))
				{
					$rft_note_counter = $modSettings['rft_note_counter'] + 1;
					$rft_note_messages = '&#8226; '.$txt['rft_note_simpelportal_off'].' '.$txt['on'].' '.date('F j, Y, h:i:s A').' '.$txt['by'].' <a href="'.$scripturl.'?action=profile;u='.$user_info['id'].'">'.$user_info['name'].'</a>';
					$rft_note_messages = $rft_note_messages .'<br />'. $modSettings['rft_note_messages'];
					$mod_settings = array(
						'rft_note_counter' => $rft_note_counter,				
						'rft_note_messages' => $rft_note_messages,
						);
						updateSettings($mod_settings);
				}
			}
		}

		
		// SP place block list
		if ((!empty($modSettings['rft_sp_block'])) && (!empty($context['rft_sp_info']['id'])))
		{					
			// Add id_block to rft_sp_block_id, only when SP is installed
			if (!empty($context['rft_sp_info']['id']))
				updateSettings(array('rft_sp_activated' => $context['rft_sp_info']['id']));
			if (isset($_REQUEST['block_id']) && $_REQUEST['block_id'] == $context['rft_sp_info']['id'])
				$context['SPortal']['block']['type_text'] = $txt['rft_mod'].' '.$txt['rft_name'];
						
			// SP place block list
			if (isset($_REQUEST['area']) && ($_REQUEST['area'] == 'portalblocks'))
			{
				// Wich side part did you put it?
				$sp_sides = array('Header', 'Left', 'Top', 'Bottom', 'Right', 'Footer');
				$rft_sides = array('5', '1', '2', '3', '4', '6');
				$context['rft_sp_info']['col'] = (str_replace($rft_sides,$sp_sides,$context['rft_sp_info']['col']));
				// Final display Recent Forum Topics text on SP block list page
				if (!empty($context['blocks']['admin'.$context['rft_sp_info']['col'].''][''.$context['rft_sp_info']['id'].'']['type']))
				{
					if ($context['blocks']['admin'.$context['rft_sp_info']['col'].''][''.$context['rft_sp_info']['id'].'']['type'] == 'sp_rft')
					$context['blocks']['admin'.$context['rft_sp_info']['col'].''][''.$context['rft_sp_info']['id'].'']['type_text'] = $txt['rft_mod'].' '.$txt['rft_name'];
				}
			}
		}
	}
}

// SimpelPortal is up with active rft block !!
function sp_rft($parameters, $id, $return_parameters = false)
{		
	$block_parameters = array();

	if ($return_parameters)
		return $block_parameters;

	loadTemplate('RecentForumTopicsPortal');
}

// Show credits
function rft_copyright(&$dummy)
{
	global $context;
	
	if (isset($context['current_action']) && $context['current_action'] == 'credits')
		$context['copyrights']['mods'][] = 'Recent Forum Topics (Extended) | <a href="http://www.simplemachines.org/community/index.php?action=profile;u=314795" title="AdemaStudios">&copy 2012-2016 by Pipke</a>';
}
?>